## sra-sdk 3.0.3+dfsg

=== libs/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( CMAKE_POSITION_INDEPENDENT_CODE True )
add_compile_definitions( _LIBRARY )

add_subdirectory(kxml)
add_subdirectory(loader)
add_subdirectory(vdb-sqlite)
add_subdirectory(ngs-vdb)
add_subdirectory(ascp)
add_subdirectory(diagnose)

if( NOT WIN32 )
	add_subdirectory(general-writer)
endif()

=== libs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ..)
MODULE = libs

include $(TOP)/build/Makefile.env

=== test/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

# this is where test executables will be created
# to access tools themselves, use ${BINDIR}
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${TESTBINDIR} )
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TESTBINDIR_DEBUG} )
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TESTBINDIR_RELEASE} )

if ( NOT SINGLE_CONFIG )
	set( COMMON_LINK_LIBRARIES ${COMMON_LINK_LIBRARIES} ktst )
else()
	set( COMMON_LINK_LIBRARIES ${COMMON_LINK_LIBRARIES} ${NCBI_VDB_LIBDIR}/libktst.${STLX} )
endif()

add_subdirectory( external )
if( BUILD_TOOLS_LOADERS )
	add_subdirectory( loaders )
endif()
if( BUILD_TOOLS_INTERNAL )
	add_subdirectory( internal )
endif()

#add_subdirectory( ngs ) # moved to test/external
#add_subdirectory( align ) # moved to test/internal
#add_subdirectory( test_sanitizers ) # move to test/internal

add_subdirectory( scripts ) # mobe to test/internal

# add_subdirectory(samline) # command line tool; move to tools/internal

# add_subdirectory(tarballs) # called directly from TeamCity

=== test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ..)
MODULE = test

include $(TOP)/build/Makefile.env

=== build/docker/Makefile ===
# Make file for building SRA Toolkit docker image

ifndef VERSION
$(error VERSION needs to be set, e.g. make VERSION=2.11.1 build)
endif

DOCKER_ARCH := $(shell docker info | perl -ne'print "$$1\n" if /Architecture:\s*(\w+)/')
BRANCH?=${VERSION}rc
TAG=${DOCKER_ARCH}-${VERSION}

.DEFAULT: build
.PHONY: build push clean scan test

build:
	docker pull alpine:latest
	docker build --build-arg VDB_BRANCH=${BRANCH} --tag ncbi/sra-tools:${TAG} -f Dockerfile.build-alpine .

test:
	docker run -it --rm ncbi/sra-tools:${TAG} fastq-dump -X 5 -Z SRR000001

scan:
	docker scan --file Dockerfile.build-alpine ncbi/sra-tools:${TAG}

push:
	docker push ncbi/sra-tools:${TAG}
	@ echo docker push ncbi/sra-tools:latest

clean:
	docker image rm ncbi/sra-tools ncbi/sra-tools:${TAG}

=== libs/ascp/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set ( UNIX_SRC unix/connect.c )
set ( LINUX_SRC ${UNIX_SRC} linux/ascp-path.c )
set ( MAC_SRC ${UNIX_SRC} mac/ascp-path.c )
set ( WIN_SRC win/connect.c win/ascp-path.c )

if ( "windows" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${WIN_SRC} )
elseif( "linux" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${LINUX_SRC} )
elseif( "mac" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${MAC_SRC} )
endif()

set( SRC
    ascp.c
    ${OS_SPECIFIC_SRC}
)

GenerateStaticLibs(ascp
    "${SRC}"
)

add_compile_definitions( __mod__="libs/ascp" )
include_directories( BEFORE ${CMAKE_CURRENT_SOURCE_DIR} )

=== libs/general-writer/CMakeLists.txt ===
# libgeneral-writerx
set( SRC
	general-writer.cpp
	utf8-like-int-codec.c
)

GenerateStaticLibs( general-writer "${SRC}" )

# gw-dumper

add_executable( gw-dumper gw-dumper.cpp )
add_dependencies ( gw-dumper general-writer )
target_link_libraries ( gw-dumper
    general-writer
	${COMMON_LIBS_READ}
)

if( RUN_SANITIZER_TESTS )
	add_executable( gw-dumper-asan gw-dumper.cpp )
	add_dependencies ( gw-dumper-asan general-writer-asan )
	target_link_libraries ( gw-dumper-asan
		general-writer-asan
		${COMMON_LIBS_READ}
	)

	add_executable( gw-dumper-tsan gw-dumper.cpp )
	add_dependencies ( gw-dumper-tsan general-writer-tsan )
	target_link_libraries ( gw-dumper-tsan
		general-writer-tsan
		${COMMON_LIBS_READ}
	)
endif()

if ( NOT TOOLS_ONLY )
    add_subdirectory( test )
endif()

=== libs/general-writer/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ../..)
MODULE = libs/general-writer

include $(TOP)/build/Makefile.env

=== libs/kxml/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ../..)
MODULE = libs/kxml

include $(TOP)/build/Makefile.env

=== libs/loader/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( SRC
    progressbar
    loader-file
    loader-meta
    queue-file
    alignment-writer
    common-reader
    common-writer
    mmarray
    reference-writer
    sequence-writer
)

GenerateStaticLibsWithDefs( loader "${SRC}" "__mod__=\"libs/loader\"" "${CMAKE_SOURCE_DIR}/libs/inc" )

=== libs/loader/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ../..)
MODULE = libs/loader

include $(TOP)/build/Makefile.env

=== libs/ngs-vdb/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ../..)
MODULE = libs/ngs-vdb

include $(TOP)/build/Makefile.env

=== debian/changelog ===
sra-sdk (3.0.3+dfsg-6~deb12u1) bookworm; urgency=medium

  * Reupload to bookworm (stable).

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 13 Jul 2023 23:08:59 -0400

sra-sdk (3.0.3+dfsg-6) unstable; urgency=high

  * debian/rules: Expand $(DEB_HOST_MULTIARCH) in libngs-java.links.in.
    (Closes: #1039621.)

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 27 Jun 2023 22:14:41 -0400

sra-sdk (3.0.3+dfsg-5) unstable; urgency=medium

  * Limit libngs-java to those architectures where libs are available
    Closes: #1031853
  * DEP3 for all patches

 -- Andreas Tille <tille@debian.org>  Fri, 24 Feb 2023 11:52:27 +0100

sra-sdk (3.0.3+dfsg-4) unstable; urgency=medium

  * debian/rules: Explicitly build with signed characters (-fsigned-char).
    On arm64, where char is normally unsigned, two tests otherwise fail
    because messages reporting certain characters' numeric values formally
    differ from expectations.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 22 Jan 2023 17:04:21 -0500

sra-sdk (3.0.3+dfsg-3) unstable; urgency=medium

  * debian/copyright: Account for a second(!) version of BitMagic under
    tools/loaders/bam-loader, with copyright running through 2022.
  * debian/patches/no_sse4.2.patch (new): Don't use SSE 4.2.  It's a
    baseline violation on x86, and entirely unavailable elsewhere.
  * debian/patches/use_c_locale_for_comma (new): Stick with the C locale.
    en_US.UTF-8 isn't necessarily available, particularly on the buildds,
    and C is perfectly sufficient to ensure recognition of comma as a
    thousands separator.  (Recent versions of glibc supply a middle-ground
    C.utf8, but even that looks like overkill at the moment.)

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 22 Jan 2023 13:26:16 -0500

sra-sdk (3.0.3+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * .gitignore: Update patterns corresponding to test output.
  * debian/control:
    - Drop vestigial versioned dependency on libncbi-wvdb2.
    - Limit architecture-dependent packages to amd64 and arm64.  The only
      other architecture ncbi-vdb supports is x32, but these tools require
      a 64-bit address space.
  * debian/not-installed: Refresh.
    - Correct location of explicitly tagged lib*-static.a.
    - Drop spurious entries (with hardcoded amd64 paths, no less).
  * debian/patches/fix_ngs-c++-underlinkage.patch (new): Link libngs-c++
    against all internal dependencies.  Hold off for now on linking
    against libncbi-vdb, though anyone looking to substitute libncbi-wvdb
    would need to contrive to supply a suitable definition of
    KDBManagerMakeRead.
  * debian/patches/label_online_tests.patch: Extend as needed.  All
    existing labels confirmed to remain appropriate.
  * debian/patches/link_vdb_dynamically.patch: Extend prior to building
    tests again.  To wit, additionally cover makeinputs, from
    tools/loaders/general-loader/test. (All other tests were already OK at
    this point.)
  * debian/patches/prefer_dynamic_libraries.patch: Comment out upstream
    logic that favored static linkage.
  * debian/rules:
    - Skip rpaths, not needed even for libhdf5.
    - Explicitly enable tests, disabled by default these days.
    - Update test cleanup logic to allow for build area reuse.
  * debian/salsa-ci.yml: Retire remaining customizations.

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 20 Jan 2023 17:57:36 -0500

sra-sdk (3.0.3+dfsg-1) experimental; urgency=medium

  [ Andreas Tille ]
  * Breaks+Replaces: libncbi-vdb-dev (<< 3), libngs-sdk-dev (<< 3)
    Closes: #1024155

  [ Aaron M. Ucko ]
  * New upstream version.
  * .gitignore:
    - Unhardcode architecture name in build tree (obj-*).
    - Ignore build results under ngs/ngs-python (dist, ngs.egg-info).
  * debian/{control,salsa-ci.yml}: Build against libncbi-vdb-dev 3.0.1+.
  * debian/copyright: Account for layout changes as of 3.0.1 and drop
    references to content removed upstream, both in Files-Excluded and in
    special cases.
  * debian/patches: Update for 3.0.1+; in particular, account for layout
    changes and better support for using system libraries.
  * debian/rules:
    - Correctly accommodate multiple supported Python versions.  (I'd
      insufficiently adapted ncbi-ngs's relevant logic.)
    - Account for layout changes and CMAKE_INSTALL_LIBDIR support (with
      the latter yielding multiarch paths).
    - Clean up newly generated files under ngs/ngs-python.
  * debian/{rules,sra-toolkit.install}: Move sratools and *-orig to a new
    /usr/lib/sra-toolkit directory; repoint symlinks accordingly.
    (Closes: #1025278.)
  * Standards-Version: 4.6.2 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 18 Jan 2023 21:42:39 -0500

sra-sdk (3.0.0+dfsg-1) experimental; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Build-Depends: default-jdk, flex, bison

  [ Aaron M. Ucko ]
  * debian/control:
    - Account for consolidation of ngs-sdk (albeit with some intervening
      changes, notably library restructuring); take the opportunity to add
      a -java-doc package.0
    - Let python3-ngs bypass libncbi-ngs-dev and use libncbi-ngs3 directly.
    - Drop build dependency on libvdb-sqlite-dev, now internal to sra-sdk.
  * debian/libngs-java-doc.javadoc: Enable javadoc installation.
  * debian/{libngs-java.{jlibs,poms},ngs-java.pom(.asc)}: Adopt (and adapt)
    from ngs-sdk.
  * debian/*ngs*.examples (new): Install upstream NGS examples.
  * debian/not-installed: Ignore usr/jar/*.jar (installed elsewhere, via
    jh_installlibs), usr/lib64/lib*-static.a, usr/share/examples*
    (installed elsewhere, via dh_installexamples), and
    usr/share/javadoc/ngs-doc (installed elsewhere, via jh_installjavadoc).
  * debian/patches/use_debian_packaged_re2.patch: Comment out an
    inappropriate add_dependencies call in test/sharq/CMakeLists.txt.
  * Add more patches for remaining build issues: fix_javadoc_build.patch,


=== debian/control ===
Source: sra-sdk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>,
           Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               d-shlibs,
               dh-python,
               javahelper,
               libncbi-vdb-dev (>= 3.0.1+dfsg~),
               libfuse-dev,
               libhdf5-dev,
               libmagic-dev,
               libre2-dev,
               libxml2-dev,
               libzstd-dev,
               liblzma-dev,
               libsam-extract-dev,
               markdown | libtext-markdown-perl | discount <!nodoc>,
               maven-repo-helper,
               python3-all,
               python3-distutils,
               default-jdk,
               flex,
               bison
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/sra-sdk
Vcs-Git: https://salsa.debian.org/med-team/sra-sdk.git
Homepage: https://github.com/ncbi/sra-tools/
Rules-Requires-Root: no

Package: sra-toolkit
Architecture: amd64 arm64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: med-config
Description: utilities for the NCBI Sequence Read Archive
 Tools for reading the SRA archive, generally by converting individual runs
 into some commonly used format such as fastq.
 .
 The textual dumpers "sra-dump" and "vdb-dump" are provided in this
 release as an aid in visual inspection. It is likely that their
 actual output formatting will be changed in the near future to a
 stricter, more formalized representation[s]. PLEASE DO NOT RELY UPON
 THE OUTPUT FORMAT SEEN IN THIS RELEASE.
 .
 Other tools distributed in this package are:
  abi-dump, abi-load
  align-info
  bam-load
  cache-mgr
  cg-load
  copycat
  fasterq-dump
  fastq-dump, fastq-load
  helicos-load
  illumina-dump, illumina-load
  kar
  kdbmeta
  latf-load
  pacbio-load
  prefetch
  rcexplain
  remote-fuser
  sff-dump, sff-load
  sra-pileup, sra-sort, sra-stat, srapath
  srf-load
  test-sra
  vdb-config, vdb-copy, vdb-decrypt, vdb-encrypt, vdb-get, vdb-lock,
  vdb-passwd, vdb-unlock, vdb-validate
 .
 The "help" information will be improved in near future releases, and
 the tool options will become standardized across the set. More documentation
 will also be provided documentation on the NCBI web site.
 .
 Tool options may change in the next release. Version 1 tool options
 will remain supported wherever possible in order to preserve
 operation of any existing scripts.

Package: libngs-c++3
Multi-Arch: same
Architecture: amd64 arm64
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Next Generation Sequencing language Bindings (C++ runtime)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libngs-c++-dev
Multi-Arch: same
Architecture: amd64 arm64
Section: libdevel
Depends: ${misc:Depends},
         libngs-c++3 (= ${binary:Version})
Breaks: libncbi-vdb-dev (<< 3), libngs-sdk-dev (<< 3)
Replaces: libncbi-vdb-dev (<< 3), libngs-sdk-dev (<< 3)
Description: Next Generation Sequencing language Bindings (C++ development)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 This is the development package for C++ usage.

Package: libncbi-ngs3
Multi-Arch: same
Architecture: amd64 arm64
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Next Generation Sequencing language Bindings (full runtime)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libncbi-ngs-dev
Multi-Arch: same
Architecture: amd64 arm64
Section: libdevel
Depends: ${misc:Depends},
         libncbi-ngs3 (= ${binary:Version}),
         libngs-c++-dev (= ${binary:Version})
Description: Next Generation Sequencing language Bindings (C++ development)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 This is the full development package.

Package: libngs-java
Multi-Arch: same
Architecture: amd64 arm64
Section: java
Depends: ${java:Depends},
         ${misc:Depends},
         libngs-jni (>= ${source:Version}),
         libngs-jni (<< ${source:Version}.1~)
Recommends: ${java:Recommends}
Suggests: libngs-java-doc
Description: Next Generation Sequencing language Bindings (Java bindings)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Java bindings.

Package: libngs-jni
Multi-Arch: same
Architecture: amd64 arm64
Section: java
Depends: ${shlibs:Depends},
         libncbi-ngs3 (= ${binary:Version}),
         ${misc:Depends}
Description: Next Generation Sequencing language Bindings (Java native binding)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Java native bindings.

Package: libngs-java-doc
Multi-Arch: foreign
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Next Generation Sequencing language Bindings (Java documentation)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Documentation for the Java bindings.

Package: python3-ngs
Architecture: all
Section: python
Depends: ${python3:Depends},
         ${misc:Depends},
         libncbi-ngs3 (>= ${source:Version}),
         libncbi-ngs3 (<< ${source:Version}.1~)
Description: Next Generation Sequencing language Bindings (Python3 bindings)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Python3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

# Pregenerated with uuidgen -r
DEBIAN_GUID = 806b5c3b-0088-4732-8359-51630950d723

# +pie breaks the build
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND   = -fsigned-char
export DEB_CXXFLAGS_MAINT_APPEND = -fsigned-char

pkg := sra-toolkit

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

build3vers := $(shell py3versions -sv)

%:
	dh $@ --buildsystem=cmake \
	    --with python3,javahelper,jh_maven_repo_helper

OUTDIR=$(CURDIR)/debian/tmp

override_dh_auto_clean:
	dh_auto_clean
	rm -rf ngs/ngs-java/$(DEB_HOST_MULTIARCH)
	rm -rf ngs/ngs-bam/$(DEB_HOST_MULTIARCH)
	rm -f ngs/ngs-bam/Makefile.config
	rm -f ngs/ngs-bam/Makefile.config.install.linux.x86_64.prl
	rm -f ngs/ngs-bam/Makefile.config.linux.x86_64
	rm -f ngs/ngs-bam/reconfigure
	rm -rf ngs/ngs-sdk/ngs/unix/generic

	rm -rf ngs/ngs-sdk/$(DEB_HOST_MULTIARCH)
	rm -rf ngs/ngs-python/build ngs/ngs-python/dist
	rm -rf ngs/ngs-python/ngs.egg-info

	find test tools -name actual -type d | xargs -rt rm -rf
	rm -rf ngs/ngs-*/examples/actual/*
	rm -fv test/*/*/tmp.kfg
	rm -rf libs/ngs-vdb/test/data/SparseFragmentBlobs
	rm -rf test/external/vdb-dump/data test/loaders/bam-load/out.sra
	find tools/loaders/general-loader/test -name input | xargs -rt rm -rf
	rm -f ngs/ngs-sdk/examples/actual.txt

	-rm debian/libngs-jni.links

override_dh_auto_configure:
	dh_auto_configure -- -DVDB_LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH} \
	    -DVDB_INCDIR=/usr/include/ncbi-vdb -DBUILD_TOOLS_LOADERS=ON \
	    -DBUILD_TOOLS_INTERNAL=ON -DBUILD_TOOLS_TEST_TOOLS=ON \
	    -DCMAKE_SKIP_RPATH=ON -DTOOLS_ONLY=OFF

KFG_INC  = /usr/include/ncbi-vdb/kfg/ncbi
KFG_DEST = debian/sra-toolkit/etc/ncbi
override_dh_auto_install:
	dh_auto_install
	# build/install.sh $(KFG_INC) \
	# 		 $(CURDIR)/tools/internal/vdb-copy \
	# 		 $(KFG_DEST) \
	# 		 $(KFG_DEST) \
	# 		 debian/sra-toolkit/usr/bin \
	# 		 debian/sra-toolkit/usr/lib/$(DEB_HOST_MULTIARCH) \
	# 		 $(CURDIR)/shared/kfgsums
	build/install-kfg.sh default.kfg $(KFG_INC) $(KFG_DEST) \
			     $(KFG_INC)/kfgsums
	build/install-kfg.sh certs.kfg $(KFG_INC) $(KFG_DEST) \
			     $(KFG_INC)/kfgsums
	build/install-kfg.sh vdb-copy.kfg $(CURDIR)/tools/internal/vdb-copy \
			     $(KFG_DEST) $(CURDIR)/shared/kfgsums
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-a \
		    --exclude-la \
		    --movedev "debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/libncbi-ngs.a*" \
			usr/lib/$(DEB_HOST_MULTIARCH) \
		    --override "s/libncbi-vdb3-dev/libncbi-vdb-dev/" \
		    debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/libncbi-ngs.so
# Ignore spurious failures from pluses; --ignorelibdep only partially helps.
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-a \
		    --exclude-la \
		    --movedev "debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/lib*c++.a*" \
			usr/lib/$(DEB_HOST_MULTIARCH) \
		    --movedev "debian/tmp/usr/include/*" usr/include \
		    --ignorelibdep \
		    debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/libngs-c++.so | \
		tee /dev/stderr | LC_ALL=C grep '^[a-z]' | sh

override_dh_install:
	# upstream installs versioned *.a libs - we only want a single version
	for d in debian/lib*-dev/usr/lib/$(DEB_HOST_MULTIARCH) ; do \
	    for slib in $$d/lib*.a ; do \
		mv $$d/`readlink $$slib` $$slib ; \
		mv $$d/`readlink $$slib` $$slib ; \
	    done ; \
	done
	ls -l debian/tmp/usr/bin
	cd debian/tmp/usr/bin && \
	for bin in *-orig.* ; do \
	    base=$${bin%-orig.*} && \
	    vbase=$$(readlink "$$(readlink $$base)") && \
	    vdriver=$$(readlink "$$vbase") && \
	    mv -v $$bin $$base-orig && \
	    ln -snfv $${vdriver%%.[0-9]*} $$vbase || exit $$? ; \
	done && \
	for bin in *[a-z+] ; do \
	    bin2=$$(readlink $$bin) ; \
	    bin3=$$(readlink "$$bin2") ; \
	    case $$bin2 in \
	        $$bin.* ) rm -v $$bin2 && mv -v $$bin3 $$bin || exit $$? ;; \
	    esac ; \
	done
	mkdir debian/tmp/usr/lib/sra-toolkit
	mv debian/tmp/usr/bin/sratools debian/tmp/usr/lib/sra-toolkit
	for x in debian/tmp/usr/bin/*-orig; do \
	    mv -v $$x debian/tmp/usr/lib/sra-toolkit ; \
	    ln -snfv ../lib/sra-toolkit/sratools $${x%-orig} ; \
	done
	dh_install
	# remove susipcious file which is not executable and conflicts with package magic
	rm -f debian/*/usr/bin/magic
	# Formally supply a standard installation ID to satisfy sratools
	echo '/LIBS/GUID = "$(DEBIAN_GUID)"' >debian/$(pkg)/etc/ncbi/debian.kfg
	set -e && for i in $(build3vers); do \
	    cd ngs/ngs-python; \
	    python$$i ./setup.py install --install-layout=deb \
	        --root $(CURDIR)/debian/python3-ngs; \
	    cd ../..; \
	done
	find debian -name "*.pyc" -delete
	find debian -type d -name __pycache__ | xargs rm -rf

override_dh_installexamples:
	dh_installexamples
	find debian/*/ -name .gitignore -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-$(DEB_HOST_MULTIARCH)  && \
	    ctest --force-new-ctest-process --verbose -j1 -LE online
endif

override_dh_prep:
	dh_prep -X debian/tmp

execute_before_dh_link:
	# Putting the upstream version number (without the dfsg part) at the end of
	# symlink source in the -jni package.
	sed -e 's/\(#STRIPPED_UPSTREAM_VERSION#\)/\1$(DEB_VERSION_UPSTREAM)/' \
	    -e 's/#STRIPPED_UPSTREAM_VERSION#\(.*\)+dfsg[0-9]*/\1/' \
	    -e 's/\$$[({]DEB_HOST_MULTIARCH[)}]/$(DEB_HOST_MULTIARCH)/g' \
	    debian/libngs-jni.links.in > debian/libngs-jni.links

# require network, not automatically run
# use it when the pom file must be re-downloaded from maven repo
BASE_URL:=https://repo.maven.apache.org/maven2/gov/nih/nlm/ncbi/ngs-java
WGET=wget --no-clobber
get-poms:
	$(RM) debian/ngs-java.pom debian/ngs-java.pom.asc
	# extract upstream version
	$(WGET) -O debian/ngs-java.pom $(BASE_URL)/$(DEB_VERSION_UPSTREAM)/ngs-java-$(DEB_VERSION_UPSTREAM).pom && \
	$(WGET) -O debian/ngs-java.pom.asc $(BASE_URL)/$(DEB_VERSION_UPSTREAM)/ngs-java-$(DEB_VERSION_UPSTREAM).pom.asc
	gpg --trust-model=always --status-fd 1 --no-default-keyring --keyring debian/sra-tools.gpg --verify debian/ngs-java.pom.asc
